
function [Ifin1,Ifin2,ufin,vfin,iwx,iwy]=split(Ifin1,Ifin2,ufin,vfin, size_iw)

iwx=floor(size(Ifin1,3)/size_iw); % interrogation windows along x
iwy=floor(size(Ifin1,2)/size_iw); % interrogation windows along y

%% SPLIT
% input 1
Iprova=zeros(size(Ifin1,2),size(Ifin1,3));
Iprova(:,:)=Ifin1(1,:,:);
Iprova=imresize(Iprova,[size(Ifin1,2)-mod(size(Ifin1,2),size_iw),size(Ifin1,3)-mod(size(Ifin1,3),size_iw)]);
split_im1 = mat2cell(Iprova, size_iw*ones(1,iwy), size_iw*ones(1,iwx));

% input 2
Iprova=zeros(size(Ifin1,2),size(Ifin1,3));
Iprova(:,:)=Ifin2(1,:,:);
Iprova=imresize(Iprova,[size(Ifin1,2)-mod(size(Ifin1,2),size_iw),size(Ifin1,3)-mod(size(Ifin1,3),size_iw)]);
split_im2 = mat2cell(Iprova, size_iw*ones(1,iwy), size_iw*ones(1,iwx));

% u
Iprova=zeros(size(Ifin1,2),size(Ifin1,3));
Iprova(:,:)=ufin(1,:,:);
Iprova=imresize(Iprova,[size(Ifin1,2)-mod(size(Ifin1,2),size_iw),size(Ifin1,3)-mod(size(Ifin1,3),size_iw)]);
split_u = mat2cell(Iprova, size_iw*ones(1,iwy), size_iw*ones(1,iwx));

% v
Iprova=zeros(size(Ifin1,2),size(Ifin1,3));
Iprova(:,:)=vfin(1,:,:);
Iprova=imresize(Iprova,[size(Ifin1,2)-mod(size(Ifin1,2),size_iw),size(Ifin1,3)-mod(size(Ifin1,3),size_iw)]);
split_v = mat2cell(Iprova, size_iw*ones(1,iwy), size_iw*ones(1,iwx));


Ifin1=zeros(iwx*iwy,size_iw,size_iw);
Ifin2=zeros(iwx*iwy,size_iw,size_iw);
ufin=zeros(iwx*iwy,size_iw,size_iw);
vfin=zeros(iwx*iwy,size_iw,size_iw);

niw=1;
for i=1:iwy
    for j=1:iwx
Ifin1(niw,:,:)=cell2mat(split_im1(i,j));
Ifin2(niw,:,:)=cell2mat(split_im2(i,j));
ufin(niw,:,:)=cell2mat(split_u(i,j));
vfin(niw,:,:)=cell2mat(split_v(i,j));

niw=niw+1; % for each interrogation window
    end
end


end
