% clear
% close all
% clc

% load data from test2_sametruefield 
% launch after test2_sametruefield

%% QUALITATIVE IMPROVEMENTS: RESOLUTION + NUMBER OF IMAGE PAIRS, SINGLE NET
% test2_name=[
%     "test2_1_384x192_rkv_trained_net_1mlx2",...
%     "test2_1_768x384_rkv_trained_net_1mlx2",...
%     "test2_1_1536x768_rkv_trained_net_1mlx2",...
%     "test2_50_384x192_rkv_trained_net_1mlx2",...
%     "test2_50_768x384_rkv_trained_net_1mlx2",...
%     "test2_50_1536x768_rkv_trained_net_1mlx2",...
%     ];
% 
% %bottom=min(min(min(int_pred)));
% %top=max(max(max(int_pred)));
% 
% figure
% for i=1:length(test2_name)
%     load(test2_name(i))
%     resx=size(upred_mean,2);
%     resy=size(upred_mean,1);
%     wholex=-resx/2+0.5:1:resx/2-0.5;
%     wholey=resy/2-0.5:-1:-resy/2+0.5;
%     int_pred=sqrt(upred_mean.^2+vpred_mean.^2);
%     subplot(2,3,i)
%     contourf(wholex,wholey,int_pred)
%     axis([min(wholex),max(wholex),min(wholey),max(wholey)])
%     %caxis manual
%     %caxis([bottom top]);
%     %colorbar
%     grid on
% end

%% ERRORS: RESOLUTION + NUMBER OF IMAGE PAIRS, SINGLE NET

%rkv
ig3_name=["ig3rkv_384x192_500_noise_rhocost_div255_dec4_R1=75_ok",...
          "ig3rkv_768x384_500_noise_rhocost_div255_dec4_R1=150_ok",...
          "ig3rkv_1536x768_50_noise_rhocost_div255_dec4_R1=300_ok"];
      
% test2_name=[
%     "test2_1_384x192_rkv_trained_net_1mlx2",...
%     "test2_50_384x192_rkv_trained_net_1mlx2";...
%     "test2_1_768x384_rkv_trained_net_1mlx2",...
%     "test2_50_768x384_rkv_trained_net_1mlx2";...
%     "test2_1_1536x768_rkv_trained_net_1mlx2",...
%     "test2_50_1536x768_rkv_trained_net_1mlx2",...
%     ];
test2_name=[
    "test2_1_384x192_rkv_trained_net_1ml_x4_nocurv",...
    "test2_50_384x192_rkv_trained_net_1ml_x4_nocurv";...
    "test2_1_768x384_rkv_trained_net_1ml_x4_nocurv",...
    "test2_50_768x384_rkv_trained_net_1ml_x4_nocurv";...
    "test2_1_1536x768_rkv_trained_net_1ml_x4_nocurv",...
    "test2_50_1536x768_rkv_trained_net_1ml_x4_nocurv"];
    
fn_rkv=zeros(size(test2_name,1),size(test2_name,2));
rmseu_rkv=fn_rkv;
rmsev_rkv=fn_rkv;
biasu_rkv=fn_rkv;
biasv_rkv=fn_rkv;

for ig3_sel=1:length(ig3_name)
    load(ig3_name(ig3_sel))
    
    for test2_sel=1:size(test2_name,2)
          
        load(test2_name(ig3_sel,test2_sel))
        
        N=size(upred_mean,1)*size(upred_mean,2);
        abserr_u=upred_mean-ufin;
        abserr_v=vpred_mean-vfin;

        fn_rkv(ig3_sel,test2_sel)=sqrt(1/N*sum(sum(abserr_u.^2+abserr_v.^2)));

        rmseu_rkv(ig3_sel,test2_sel)=sqrt(1/N*sum(sum(abserr_u.^2)));
        rmsev_rkv(ig3_sel,test2_sel)=sqrt(1/N*sum(sum(abserr_v.^2)));

        biasu_rkv(ig3_sel,test2_sel)=1/N*sqrt(sum(sum(abs(abserr_u),1)));
        biasv_rkv(ig3_sel,test2_sel)=1/N*sqrt(sum(sum(abs(abserr_v),1)));
        
    end
        
end
%%
% rkv + s
ig3_name=["ig3rkv_s_384x192_500_noise_rhocost_div255_dec4_R1=75_J=0p0100_ok",...
          "ig3rkv_s_768x384_500_noise_rhocost_div255_dec4_R1=150_J=0p0050_ok",...
          "ig3rkv_s_1536x768_50_noise_rhocost_div255_dec4_R1=300_J=0p002500_ok"];
      
test2_name=[
    "test2_1_384x192_rkv_s_trained_net_1mlx2",...
    "test2_50_384x192_rkv_s_trained_net_1mlx2";...
    "test2_1_768x384_rkv_s_trained_net_1mlx2",...
    "test2_50_768x384_rkv_s_trained_net_1mlx2";...
    "test2_1_1536x768_rkv_s_trained_net_1mlx2",...
    "test2_50_1536x768_rkv_s_trained_net_1mlx2",...
    ];
    
fn_rkvs=zeros(size(test2_name,1),size(test2_name,2));
rmseu_rkvs=fn_rkvs;
rmsev_rkvs=fn_rkvs;
biasu_rkvs=fn_rkvs;
biasv_rkvs=fn_rkvs;

for ig3_sel=1:length(ig3_name)
    load(ig3_name(ig3_sel))
    
    for test2_sel=1:size(test2_name,2)
          
        load(test2_name(ig3_sel,test2_sel))
        
        N=size(upred_mean,1)*size(upred_mean,2);
        abserr_u=upred_mean-ufin;
        abserr_v=vpred_mean-vfin;

        fn_rkvs(ig3_sel,test2_sel)=sqrt(1/N*sum(sum(abserr_u.^2+abserr_v.^2)));

        rmseu_rkvs(ig3_sel,test2_sel)=sqrt(1/N*sum(sum(abserr_u.^2)));
        rmsev_rkvs(ig3_sel,test2_sel)=sqrt(1/N*sum(sum(abserr_v.^2)));

        biasu_rkvs(ig3_sel,test2_sel)=1/N*sqrt(sum(sum(abs(abserr_u),1)));
        biasv_rkvs(ig3_sel,test2_sel)=1/N*sqrt(sum(sum(abs(abserr_v),1)));
        
    end
        
end
%% PLOT
ig3_labels=categorical({'1';'50'});
ig3_labels=reordercats(ig3_labels, {'1';'50'});

figure
for ig3_sel=1:length(ig3_name)
p=plot(ig3_labels,fn_rkv(ig3_sel,:));
p.Marker='*';
hold on
xlabel('image pairs')
ylabel('Frobenius norm')
grid on
end
hold on

legend('384 x 192 px', '768 x 384 px', '1536 x 768 px')

figure
subplot(1,2,1)
for ig3_sel=1:length(ig3_name)
p=plot(ig3_labels,rmseu_rkv(ig3_sel,:));
p.Marker='*';
hold on
xlabel('image pairs')
ylabel('RMSE(u)')
grid on
end
legend('384 x 192 px', '768 x 384 px', '1536 x 768 px')

subplot(1,2,2)
for ig3_sel=1:length(ig3_name)
p=plot(ig3_labels,fn_rkv(ig3_sel,:));
p.Marker='*';
hold on
xlabel('image pairs')
ylabel('RMSE(v)')
grid on
end
legend('384 x 192 px', '768 x 384 px', '1536 x 768 px')

figure
subplot(1,2,1)
for ig3_sel=1:length(ig3_name)
p=plot(ig3_labels,fn_rkv(ig3_sel,:));
p.Marker='*';
hold on
xlabel('image pairs')
ylabel('bias(u)')
grid on
end
legend('384 x 192 px', '768 x 384 px', '1536 x 768 px')

subplot(1,2,2)
for ig3_sel=1:length(ig3_name)
p=plot(ig3_labels,fn_rkv(ig3_sel,:));
p.Marker='*';
hold on
xlabel('image pairs')
ylabel('bias(v)')
grid on
end
legend('384 x 192 px', '768 x 384 px', '1536 x 768 px')

%% BARS: resolution, number of image pairs, type of benchmark

fn=[fn_rkv,fn_rkvs];
rmseu=[rmseu_rkv,rmseu_rkvs];
rmsev=[rmsev_rkv, rmsev_rkvs];
biasu=[biasu_rkv,biasu_rkvs];
biasv=[biasv_rkv, biasv_rkvs];


ig3_labels=categorical({'384x192 px';'768x384 px';'1536x768 px'});
ig3_labels=reordercats(ig3_labels, {'384x192 px';'768x384 px';'1536x768 px'});

figure('Renderer', 'painters', 'Position', [300 300 900 400])
b=bar(ig3_labels,round(fn,4));
ylabel('Frobenius norm')
grid on
ylim([0,0.16])
legend('rkv, 1 im', 'rkv, 50 im', 'rkv+s, 1 im', 'rkv+s, 50 im')
for i=1:size(fn,2)
xtips1 = b(i).XEndPoints;
ytips1 = b(i).YEndPoints;
labels1 = string(b(i).YData);
text(xtips1,ytips1,labels1,'HorizontalAlignment','center',...
    'VerticalAlignment','bottom')
end

figure('Renderer', 'painters', 'Position', [300 300 900 400])
subplot(1,2,1)
b=bar(ig3_labels,rmseu);
hold on
ylabel('RMSE(u)')
grid on
legend('rkv, 1 im', 'rkv, 50 im', 'rkv+s, 1 im', 'rkv+s, 50 im')
% for i=1:size(fn,2)
% xtips1 = b(i).XEndPoints;
% ytips1 = b(i).YEndPoints;
% labels1 = string(b(i).YData);
% text(xtips1,ytips1,labels1,'HorizontalAlignment','center',...
%     'VerticalAlignment','bottom')
% end

%figure('Renderer', 'painters', 'Position', [300 300 900 400])
subplot(1,2,2)
b = bar(ig3_labels,rmsev);
hold on
ylabel('RMSE(v)')
grid on
ylim([0, 0.115])
legend('rkv, 1 im', 'rkv, 50 im', 'rkv+s, 1 im', 'rkv+s, 50 im')
% for i=1:size(fn,2)
% xtips1 = b(i).XEndPoints;
% ytips1 = b(i).YEndPoints;
% labels1 = string(b(i).YData);
% text(xtips1,ytips1,labels1,'HorizontalAlignment','center',...
%     'VerticalAlignment','bottom')
% end

figure('Renderer', 'painters', 'Position', [300 300 900 400])
subplot(1,2,1)
b = bar(ig3_labels,biasu);
hold on
ylabel('bias(u)')
grid on
ylim([0, 0.00111])
legend('rkv, 1 im', 'rkv, 50 im', 'rkv+s, 1 im', 'rkv+s, 50 im')
% for i=1:size(fn,2)
% xtips1 = b(i).XEndPoints;
% ytips1 = b(i).YEndPoints;
% labels1 = string(b(i).YData);
% text(xtips1,ytips1,labels1,'HorizontalAlignment','center',...
%     'VerticalAlignment','bottom')
% end

subplot(1,2,2)
%figure('Renderer', 'painters', 'Position', [300 300 900 400])
b = bar(ig3_labels,biasv);
hold on
ylabel('bias(v)')
grid on
ylim([0, 0.00111])
legend('rkv, 1 im', 'rkv, 50 im', 'rkv+s, 1 im', 'rkv+s, 50 im')
% for i=1:size(fn,2)
% xtips1 = b(i).XEndPoints;
% ytips1 = b(i).YEndPoints;
% labels1 = string(b(i).YData);
% text(xtips1,ytips1,labels1,'HorizontalAlignment','center',...
%     'VerticalAlignment','bottom')
% end


