clear
%close all
clc

% reference field must be generated using a separate script/tool (ex. PIVlab: https://pivlab.blogspot.com )
% particle images must be saved in the same folder of this script

%% LOAD SINGLE NET

% INTERESTING MODELS
namenet_v=[
    "trained_net1",...
    "",...
    "",...
    "",...
    ""];

for nn=5 % which networks?
    namenet=namenet_v(nn);
    load(namenet)

%% LOAD DATA
for numbername=1 % which particle images?
    
%% analyze CHALLENGING VORTEX ( http://www.pivchallenge.org/ )
% dataname=append('B00',num2str(numbername));
% string1=append(dataname,'_1.tif');
% string2=append(dataname,'_2.tif');
% 
% Ifin1_aux=imread(string1)/255;
% Ifin1=zeros(1,size(Ifin1_aux,1),size(Ifin1_aux,2));
% Ifin2=zeros(1,size(Ifin1_aux,1),size(Ifin1_aux,2));
% Ifin1(1,:,:)=Ifin1_aux; % exposition 1
% Ifin2(1,:,:)=imread(string2)/255; % exposition 2
% clear Ifin1_aux


%% analyze TURBULENT BOUNDARY LAYER
% dataname=append('bgrem_Liscia_cam0');
% string1=append(dataname,'_a00200.tif');
% string2=append(dataname,'_b00200.tif');
% 
% Ifin1_aux=double(imread(string1))/255; % exposition 1, auxiliary variable
% Ifin1=zeros(1,size(Ifin1_aux,1),size(Ifin1_aux,2));
% Ifin2=zeros(1,size(Ifin1_aux,1),size(Ifin1_aux,2));
% Ifin1(1,:,:)=Ifin1_aux; % exposition 1
% Ifin2(1,:,:)=double(imread(string2))/255; % exposition 2


%% analyze TURBULENT JET (FRACTAL GRID)
% dataname=append('Fig8_0_PP_cam0');
% string1=append(dataname,'_a00250.tif');
% string2=append(dataname,'_b00250.tif');
% 
% Ifin1_aux=double(imread(string1))/255; % exposition 1, auxiliary variable
% Ifin1=zeros(1,size(Ifin1_aux,1),size(Ifin1_aux,2));
% Ifin2=zeros(1,size(Ifin1_aux,1),size(Ifin1_aux,2));
% Ifin1(1,:,:)=Ifin1_aux; % exposition 1
% Ifin2(1,:,:)=double(imread(string2))/255; % exposition 2


%% images from PIVlab PREPROCESSING
dataname=append('tbl6')%, num2str(numbername))%,'px');
string1=append(dataname,'_1.pgm');
string2=append(dataname,'_2.pgm');

Ifin1_aux=imread(string1)/255;
Ifin1=zeros(1,size(Ifin1_aux,1),size(Ifin1_aux,2));
Ifin2=Ifin1;
Ifin1(1,:,:)=Ifin1_aux;
Ifin2(1,:,:)=imread(string2)/255;

%%

size_iw=32; % size of interrogation window
nip=size(Ifin1,1);

% figure
% imshow(squeeze(Ifin1(1,:,:)))
% figure
% imshow(squeeze(Ifin2(1,:,:)))
%% REARRANGE DATA
[Ifin1_split,Ifin2_split,iwx,iwy]=split_onlypred(Ifin1,Ifin2,size_iw);

XTest=zeros(size(Ifin1_split,1),size_iw,size_iw,2);
XTest(:,:,:,1)=Ifin1_split;
XTest(:,:,:,2)=Ifin2_split; 

XTest=permute(XTest, [2 3 4 1]); % [resx, resy, channel, number of images]


%% PREDICT

YPred=predict(net, XTest);

%% RECONSTRUCT VELOCITY FIELDS (each interrogation window)

x=-15.5:1:15.5;
y=15.5:-1:-15.5;

upred=zeros(size(Ifin1_split,1),size(Ifin1_split,2), size(Ifin1_split,3));
vpred=zeros(size(Ifin1_split,1),size(Ifin1_split,2), size(Ifin1_split,3));
ureal=zeros(size(Ifin1_split,1),size(Ifin1_split,2), size(Ifin1_split,3));
vreal=zeros(size(Ifin1_split,1),size(Ifin1_split,2), size(Ifin1_split,3));

int_pred=zeros(size(Ifin1_split,1), size(Ifin1_split,2), size(Ifin1_split,3)); % int=intensity
int_real=zeros(size(Ifin1_split,1), size(Ifin1_split,2), size(Ifin1_split,3));

int_p=zeros(size(Ifin1_split,2), size(Ifin1_split,3)); % auxiliary variable
int_r=zeros(size(Ifin1_split,2), size(Ifin1_split,3)); % auxiliary variable

for k=1:size(Ifin1_split,1)

upredf= @(xx,yy) YPred(k,1)+YPred(k,[3,4])*[xx;yy]; % predicted velocity field
vpredf= @(xx,yy) YPred(k,2)+YPred(k,[5,6])*[xx;yy];

for i=1:length(x)
    for j=1:length(y)
upred(k,j,i)=upredf(x(i),y(j));
vpred(k,j,i)=vpredf(x(i),y(j));

int_pred(k,j,i)=sqrt(upred(k,j,i).^2+vpred(k,j,i).^2);
    end
end

end

%% RECOMPOSE  WHOLE IMAGES

% initialize variables for speed
whole_upred=zeros(1,size(Ifin1,2),size(Ifin1,3));
whole_vpred=whole_upred;
whole_int_pred=whole_upred;

niw=1;
for i=1:iwy
    for j=1:iwx
whole_upred(nip,1+(i-1)*size_iw:size_iw+(i-1)*size_iw,1+(j-1)*size_iw:size_iw+(j-1)*size_iw)=upred(niw,:,:);
whole_vpred(nip,1+(i-1)*size_iw:size_iw+(i-1)*size_iw,1+(j-1)*size_iw:size_iw+(j-1)*size_iw)=vpred(niw,:,:);
whole_int_pred(nip,1+(i-1)*size_iw:size_iw+(i-1)*size_iw,1+(j-1)*size_iw:size_iw+(j-1)*size_iw)=int_pred(niw,:,:);

niw=niw+1; % for each interrogation window
    end
end


%% VISUALIZE WHOLE IMAGE

passo=30;
wholex=-size(Ifin1,3)/2+0.5:1:size(Ifin1,3)/2-0.5;
wholey=size(Ifin1,2)/2-0.5:-1:-size(Ifin1,2)/2+0.5;

whole_upred_a=zeros(size(Ifin1,2),size(Ifin1,3)); % auxiliary variables
whole_vpred_a=whole_upred_a;

whole_upred_a(:,:)=whole_upred(nip,:,:); % fill auxiliary variables
whole_vpred_a(:,:)=whole_vpred(nip,:,:); 


%load(stringpl)
%load pivlab_A001

%whole_int_pl=sqrt(u_original{1,1}.^2+v_original{1,1}.^2);



figure('units','normalized','outerposition',[0 0 1 1])
sgtitle(append(dataname, namenet))

% predicted direction
%subplot(2,2,1)
figure
quiver(wholex(1:passo:end), wholey(1:passo:end), whole_upred_a(1:passo:end,1:passo:end), whole_vpred_a(1:passo:end,1:passo:end))
xlabel('x [px]')
ylabel('y [px]')
axis([min(wholex),max(wholex),min(wholey),max(wholey)])
title('predicted direction')
grid on

% direction by pivlab
% subplot(2,2,2)
% %quiver(wholex_pl, wholey_pl, u_original{1,1}, v_original{1,1})
% quiver(x{1,1}, y{1,1}, -u_original{1,1}, -v_original{1,1})
% 
% xlabel('x [px]')
% ylabel('y [px]')
% %axis([min(wholex_pl),max(wholex_pl),min(wholey_pl),max(wholey_pl)])
% axis([min(min(x{1,1})),max(max(x{1,1})),min(min(y{1,1})),max(max(y{1,1}))])
% title('True field, direction')
% grid on

%bottom = min(min(min(min(int_pred))),min(min(min(whole_int_pl))));
%top  = max(max(max(max(int_pred))),max(max(max(whole_int_pl))));

% % intensity by pivlab
% subplot(2,2,4)
% %contourf(wholex_pl,wholey_pl,whole_int_pl)
% contourf(x{1,1},y{1,1},whole_int_pl)
% xlabel('x [px]')
% ylabel('y [px]')
% %axis([min(wholex_pl),max(wholex_pl),min(wholey_pl),max(wholey_pl)])
% axis([min(min(x{1,1})),max(max(x{1,1})),min(min(y{1,1})),max(max(y{1,1}))])
% title('True field, intensity')
% caxis manual
% caxis([bottom top]);
% colorbar
% grid on

% predicted intensity
whole_upred_a(:,:)=whole_int_pred(nip,:,:);
figure
%subplot(2,2,2) 
contourf(wholex,wholey,whole_upred_a)
xlabel('x [px]')
ylabel('y [px]')
axis([min(wholex),max(wholex),min(wholey),max(wholey)])
title('predicted intensity')
%caxis manual
%caxis([bottom top]);
colorbar
grid on


% savename=append(dataname, '__',namenet)
% save(savename, 'whole_upred', 'whole_vpred')

end
end










